\ Breuken         -- Fractions   \ Albert Nijhof, 12feb2007
\ Worteltrekken 1 -- Square root 1 \ 16 or 32bits

\ This file SQR1.F needs no other files.

\ PSQR1

\ PSQR2 (in file SQR2.F) is better than this PSQR1

\ u2 is rounded unless FFFF(FFFF)
: dsqr ( du1 -- u2 ) \ sqr(du1) = u2
  2dup 0= negate 2* u< if drop exit then
  -3 over u< if 2drop -1 exit then
  2>r  r@ 1+                     \ first-guess = g1
  begin dup 2r@ rot um/mod nip   \ g1 du/g1
        1 rshift over 1 rshift + \ better: g2=(du1/g1)/2 + g1/2
        tuck - abs 2 u<          \ |g2-g1|<2?
  until dup dup 1+ um*
  dup r@ =                       \ g*(g+1) < du1 ?
  if   drop 2r> drop
  else nip  2r>  nip
  then u< - ;                    \ Add 1 when true

: psqr1 ( t1 n1 -- t2 n2 ) \ t2/n2 = sqr t1/n1 
  2dup or 0< if 2drop false dup then
  2dup < dup >r  if swap then     \ big small r: swapflag
  dup
  if   swap 0 0
       do   [ -1 1 rshift dup 1 rshift xor ]  \ 01000000...
            literal over and
            if   swap i  lshift leave       \ big small
            then 2* \ shift left as far as possible for best precision
       loop over um* dsqr                     \ X  sqr(Y*X)
  then r> if swap then ;

\ sqr x/y =  X / sqr Y*X      for X = x*(2^i) and Y = y*(2^i)

cr .( ----- sqr.f is geladen ----- )





